Summary:	Handles slow HTTP requests for GitLab
Name:		gitlab-workhorse
Version:	3.3.1
Release:	1
License:	MIT
Group:		Networking/Daemons/HTTP
Source0:	https://gitlab.com/gitlab-org/gitlab-workhorse/repository/archive.tar.bz2?ref=v%{version}&/%{name}-%{version}.tar.bz2
# Source0-md5:	5e8c97210890028d440b5da19f95d5ad
Source1:	%{name}.service
Source2:	%{name}.init
Source3:	%{name}.sysconfig
Patch0:		paths.patch
URL:		https://gitlab.com/gitlab-org/gitlab-workhorse
BuildRequires:	git-core
BuildRequires:	golang >= 1.8
BuildRequires:	rpmbuild(macros) >= 1.647
Requires(post,preun):	/sbin/chkconfig
Requires:	rc-scripts >= 0.4.16
Requires:	systemd-units >= 0.38
Obsoletes:	gitlab-git-http-server <= 0.3.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Gitlab-workhorse is a smart reverse proxy for GitLab. It handles
"large" HTTP requests such as file downloads, file uploads, Git
push/pull and Git archive downloads.

%prep
%setup -qc
mv %{name}-v%{version}-*/* .
%patch0 -p1

%build
# make version similar when built from git:
# Starting gitlab-workhorse v0.7.1-20160404.102052
version=v%{version}-$(date -u +%%Y%%m%%d.%%H%%M%%S)

%{__make} \
	VERSION=$version

# verify
./gitlab-workhorse --version > v
grep "$version" v

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{systemdunitdir},/etc/{rc.d/init.d,sysconfig}}

%{__make} install \
	PREFIX=%{_prefix} \
	DESTDIR=$RPM_BUILD_ROOT

cp -p %{SOURCE1} $RPM_BUILD_ROOT%{systemdunitdir}/%{name}.service
install -p %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
cp -p %{SOURCE3} $RPM_BUILD_ROOT/etc/sysconfig/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add %{name}
%service %{name} restart
%systemd_post %{name}.service

%preun
if [ "$1" = "0" ]; then
	%service -q %{name} stop
	/sbin/chkconfig --del %{name}
fi
%systemd_preun %{name}.service

%postun
%systemd_reload

%files
%defattr(644,root,root,755)
%doc CHANGELOG README.md LICENSE
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/%{name}
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%attr(755,root,root) %{_sbindir}/gitlab-workhorse
%attr(755,root,root) %{_sbindir}/gitlab-zip-cat
%attr(755,root,root) %{_sbindir}/gitlab-zip-metadata
%{systemdunitdir}/%{name}.service
%changelog
* Sun Dec 17 2017 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/gitlab-workhorse.git;a=log;h=master

* Sun Dec 17 2017 Elan Ruusamäe <glen@pld-linux.org> 0d57fdb
- use make install to ensure all binaries get installed

* Sun Dec 17 2017 Elan Ruusamäe <glen@pld-linux.org> 536130a
- up to 3.3.1

* Thu Nov 02 2017 Elan Ruusamäe <glen@pld-linux.org> 2e2038b
- up to 3.3.0

* Wed Apr 26 2017 Elan Ruusamäe <glen@delfi.ee> 764d64f
- up to 1.4.3

* Mon Jan 23 2017 Elan Ruusamäe <glen@delfi.ee> 77cd1e6
- v1.3.0

* Fri Dec 23 2016 Elan Ruusamäe <glen@delfi.ee> 4347ed7
- up to 1.2.1

* Fri Dec 23 2016 Elan Ruusamäe <glen@delfi.ee> 69b04eb
- up to 1.1.1

* Tue Dec 06 2016 Elan Ruusamäe <glen@delfi.ee> 6d37e2c
- up to 1.0.1

* Tue Dec 06 2016 Elan Ruusamäe <glen@delfi.ee> 0d57ad7
- up to 1.0.0

* Thu Nov 03 2016 Elan Ruusamäe <glen@delfi.ee> 6d2a450
- configurable listen options

* Sun Oct 23 2016 Elan Ruusamäe <glen@delfi.ee> bc26cb6
- up to 0.8.5

* Fri Sep 23 2016 Elan Ruusamäe <glen@delfi.ee> 027df84
- requires rc-scripts >= 0.4.16 for daemon --fork --makepid bug

* Fri Sep 23 2016 Elan Ruusamäe <glen@delfi.ee> ece2e78
- up to 0.8.2, required by gitlab 8.12

* Fri Sep 09 2016 Elan Ruusamäe <glen@delfi.ee> 2681698
- link for explanation why RC_LOGGING=yes fails

* Mon Sep 05 2016 Elan Ruusamäe <glen@delfi.ee> dd378d8
- use /var/run/gitlab directly for pid path

* Mon Sep 05 2016 Elan Ruusamäe <glen@delfi.ee> c915e50
- actually install sysv initscript

* Mon Sep 05 2016 Elan Ruusamäe <glen@delfi.ee> d0ff683
- requires go 1.5 actually

* Sun Sep 04 2016 Elan Ruusamäe <glen@delfi.ee> 4d0d4ea
- redirfds hack

* Sun Sep 04 2016 Elan Ruusamäe <glen@delfi.ee> 913d015
- add sysv initscript; works for me rel 1

* Sun Sep 04 2016 Elan Ruusamäe <glen@delfi.ee> 46a30a0
- add tcp listen example

